/// @file
////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Copyright (C) 2016/17      Christian Lessig, Otto-von-Guericke Universitaet Magdeburg
///
////////////////////////////////////////////////////////////////////////////////////////////////////
///
///  module     : lecture 6
///
///  author     : lessig@isg.cs.ovgu.de
///
///  project    : GPU Programming
///
///  description: race conditions
///
////////////////////////////////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <vector>
#include <thread>
#include <cstdlib>
#include <future>

////////////////////////////////////////////////////////////////////////////////////////////////////
// Compute large prime
////////////////////////////////////////////////////////////////////////////////////////////////////
int
computeLargePrime() {
  // do a lot of work
  return 0;
}

////////////////////////////////////////////////////////////////////////////////////////////////////
// Compute large prime
////////////////////////////////////////////////////////////////////////////////////////////////////
template<typename T>
void
encodeMessage( T& prime) {

  std::cout << "prime : " << prime.get() << std::endl;;
}

////////////////////////////////////////////////////////////////////////////////////////////////////
// program entry point
////////////////////////////////////////////////////////////////////////////////////////////////////
int
main( int /*argc*/, char** /*argv*/ ) {

  std::future<int> prime = std::async( std::launch::async, computeLargePrime);
  encodeMessage( prime);

  return EXIT_SUCCESS;
}
