/// @file
////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Copyright (C) 2016/17      Christian Lessig, Otto-von-Guericke Universitaet Magdeburg
///
////////////////////////////////////////////////////////////////////////////////////////////////////
///
///  module     : lecture 6
///
///  author     : lessig@isg.cs.ovgu.de
///
///  project    : GPU Programming
///
///  description: race conditions
///
////////////////////////////////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <vector>
#include <thread>
#include <cstdlib>
#include <future>


std::promise<int> channel;

////////////////////////////////////////////////////////////////////////////////////////////////////
// worker
////////////////////////////////////////////////////////////////////////////////////////////////////
void
worker1( std::future<int>& fut) {
  std::cout << "t1 : " << fut.get() << std::endl;
}

////////////////////////////////////////////////////////////////////////////////////////////////////
// worker
////////////////////////////////////////////////////////////////////////////////////////////////////
void
worker2() {

  int comp = 10;
  getchar();

  channel.set_value( comp);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
// program entry point
////////////////////////////////////////////////////////////////////////////////////////////////////
int
main( int /*argc*/, char** /*argv*/ ) {

  std::future<int> fut = channel.get_future();

  std::thread t1( worker1, std::ref( fut));
  std::thread t2( worker2);

  t1.join();
  t2.join();


  return EXIT_SUCCESS;
}
